import sys
import re
import math
import commands

one_file = re.compile(r"(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*),(.*)")
def estimate(s1, s2, n, original_p):
	upper=n
	lower=n/4

	SS1=float(((math.pow(2,s1))+1))/2
	SS2=float(((math.pow(2,s2))+1))/2
	CH = (original_p * (math.log( n )/math.log(2)) )/ n 

	val_upper = upper + upper/SS1 - (upper*CH*SS2)/((math.log(upper)/math.log(2))*SS1)
	val_lower = lower + lower/SS1 - (lower*CH*SS2)/((math.log(lower)/math.log(2))*SS1)

	middle = (upper + lower) /2
	val_middle = middle + middle/SS1 - (middle*CH*SS2)/((math.log(middle)/math.log(2))*SS1)
	while ((val_middle - n) < -10) or ((val_middle - n )>10):
		if val_middle > n:
			upper = middle
			middle = (lower + upper) /2
			val_middle =  middle + middle/SS1 - (middle*CH*SS2)/((math.log(middle)/math.log(2))*SS1)
		else :
			lower = middle 
			middle = (lower + upper) /2
			val_middle =  middle + middle/SS1 - (middle*CH*SS2)/((math.log(middle)/math.log(2))*SS1)

	new_p = CH * middle / (math.log(middle)/math.log(2))
	bits = (new_p / SS1) * (s1+s2)
	bytes = bits / 8
	total_p = new_p + (new_p / SS1)
	result = [new_p, bits, bytes, total_p]
	return result

#s1=int(sys.argv[1])
#s2=int(sys.argv[2])
#n=float(sys.argv[3])
#original_p=float(sys.argv[4])

inputfile = open("report.csv")
i=0
print "filename, interval_bits, length_bits, bytes embedded, estimated bytes embedded , accuracy "
while i<16:
	j = 0
	#print "Parameters:"+ str((i/2 + 1))+ ","  + str((i % 2))
	while j < 6 :
		one_line = inputfile.readline()
		#print one_line
		j = j + 1
		parameters = one_file.match(one_line)
		s1 = i / 2 +1
		s2 = i % 2
		n = int(parameters.group(2)) * int(parameters.group(2))
		original_p = int(parameters.group(6))
		#print "s1="+str(s1)+",s2="+str(s2)+",n="+str(n)+",original_p="+str(original_p)
		result = estimate(s1,s2,n,original_p)
		print parameters.group(1) + "," + str(s1) + "," + str(s2)+"," + parameters.group(11) + "," + str(int(result[2]))+","+ str((result[2] - int(parameters.group(11)))/int(parameters.group(11)))
	one_line = inputfile.readline()
	i= i + 1 
 

#output = estimate(s1,s2,n,original_p)
#print output[0]
#print output[1]
#print output[2]
#print output[3]
